# coding: utf-8

from __future__ import absolute_import
from swagger_server.models.distributor_data import DistributorData
from swagger_server.models.part_offer import PartOffer
from .base_model_ import Model
from datetime import date, datetime
from typing import List, Dict
from ..util import deserialize_model


class PartDistributor(Model):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, name=None, address=None, website=None, sku_url=None, email=None, phone=None, comment=None, allowed=None, id=None, offers=None):
        """
        PartDistributor - a model defined in Swagger

        :param name: The name of this PartDistributor.
        :type name: str
        :param address: The address of this PartDistributor.
        :type address: str
        :param website: The website of this PartDistributor.
        :type website: str
        :param sku_url: The sku_url of this PartDistributor.
        :type sku_url: str
        :param email: The email of this PartDistributor.
        :type email: str
        :param phone: The phone of this PartDistributor.
        :type phone: str
        :param comment: The comment of this PartDistributor.
        :type comment: str
        :param allowed: The allowed of this PartDistributor.
        :type allowed: bool
        :param id: The id of this PartDistributor.
        :type id: int
        :param offers: The offers of this PartDistributor.
        :type offers: List[PartOffer]
        """
        self.swagger_types = {
            'name': str,
            'address': str,
            'website': str,
            'sku_url': str,
            'email': str,
            'phone': str,
            'comment': str,
            'allowed': bool,
            'id': int,
            'offers': List[PartOffer]
        }

        self.attribute_map = {
            'name': 'name',
            'address': 'address',
            'website': 'website',
            'sku_url': 'sku_url',
            'email': 'email',
            'phone': 'phone',
            'comment': 'comment',
            'allowed': 'allowed',
            'id': 'id',
            'offers': 'offers'
        }

        self._name = name
        self._address = address
        self._website = website
        self._sku_url = sku_url
        self._email = email
        self._phone = phone
        self._comment = comment
        self._allowed = allowed
        self._id = id
        self._offers = offers

    @classmethod
    def from_dict(cls, dikt):
        """
        Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The PartDistributor of this PartDistributor.
        :rtype: PartDistributor
        """
        return deserialize_model(dikt, cls)

    @property
    def name(self):
        """
        Gets the name of this PartDistributor.

        :return: The name of this PartDistributor.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this PartDistributor.

        :param name: The name of this PartDistributor.
        :type name: str
        """

        self._name = name

    @property
    def address(self):
        """
        Gets the address of this PartDistributor.

        :return: The address of this PartDistributor.
        :rtype: str
        """
        return self._address

    @address.setter
    def address(self, address):
        """
        Sets the address of this PartDistributor.

        :param address: The address of this PartDistributor.
        :type address: str
        """

        self._address = address

    @property
    def website(self):
        """
        Gets the website of this PartDistributor.

        :return: The website of this PartDistributor.
        :rtype: str
        """
        return self._website

    @website.setter
    def website(self, website):
        """
        Sets the website of this PartDistributor.

        :param website: The website of this PartDistributor.
        :type website: str
        """

        self._website = website

    @property
    def sku_url(self):
        """
        Gets the sku_url of this PartDistributor.

        :return: The sku_url of this PartDistributor.
        :rtype: str
        """
        return self._sku_url

    @sku_url.setter
    def sku_url(self, sku_url):
        """
        Sets the sku_url of this PartDistributor.

        :param sku_url: The sku_url of this PartDistributor.
        :type sku_url: str
        """

        self._sku_url = sku_url

    @property
    def email(self):
        """
        Gets the email of this PartDistributor.

        :return: The email of this PartDistributor.
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """
        Sets the email of this PartDistributor.

        :param email: The email of this PartDistributor.
        :type email: str
        """

        self._email = email

    @property
    def phone(self):
        """
        Gets the phone of this PartDistributor.

        :return: The phone of this PartDistributor.
        :rtype: str
        """
        return self._phone

    @phone.setter
    def phone(self, phone):
        """
        Sets the phone of this PartDistributor.

        :param phone: The phone of this PartDistributor.
        :type phone: str
        """

        self._phone = phone

    @property
    def comment(self):
        """
        Gets the comment of this PartDistributor.

        :return: The comment of this PartDistributor.
        :rtype: str
        """
        return self._comment

    @comment.setter
    def comment(self, comment):
        """
        Sets the comment of this PartDistributor.

        :param comment: The comment of this PartDistributor.
        :type comment: str
        """

        self._comment = comment

    @property
    def allowed(self):
        """
        Gets the allowed of this PartDistributor.

        :return: The allowed of this PartDistributor.
        :rtype: bool
        """
        return self._allowed

    @allowed.setter
    def allowed(self, allowed):
        """
        Sets the allowed of this PartDistributor.

        :param allowed: The allowed of this PartDistributor.
        :type allowed: bool
        """

        self._allowed = allowed

    @property
    def id(self):
        """
        Gets the id of this PartDistributor.

        :return: The id of this PartDistributor.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this PartDistributor.

        :param id: The id of this PartDistributor.
        :type id: int
        """

        self._id = id

    @property
    def offers(self):
        """
        Gets the offers of this PartDistributor.

        :return: The offers of this PartDistributor.
        :rtype: List[PartOffer]
        """
        return self._offers

    @offers.setter
    def offers(self, offers):
        """
        Sets the offers of this PartDistributor.

        :param offers: The offers of this PartDistributor.
        :type offers: List[PartOffer]
        """

        self._offers = offers

